unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    Edit2: TEdit;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    function englishword(n: Integer): String;
    function english(money: Real): String;
    function englishnew(money: Integer): String;
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
 edit2.text:=english(strtofloat(edit1.text));
end;


function TForm1.english(money: Real): String;
Var
 i,k: Integer;
 smoney,s,r,t,ch,word,eng:String;
begin
 r:='';
 smoney:=floattoStr(money);
 if pos('.',smoney)>0 then
  begin
   s:=copy(smoney,1,pos('.',smoney)-1);
   r:= copy(smoney,pos('.',smoney)+1,length(smoney));
  end
 else s:=smoney;

 eng:=englishnew(strtoint(s));

 while length(r)<2 do r:=r+'0';
 if r<>'' then
  begin
   t:='';
   while length(t)<length(r) do
   begin
    t:=t+'0';
   end;
   t:='1'+t;

  if eng<>'' then
   eng:=eng+' and '+r+'/'+t
  else eng:=r+'/'+t;
  end;
 result:=eng;
end;



function TForm1.englishnew(money: Integer): String;
Var
 len,num: integer;
 s,ch,eng : String;
begin
 eng:='';
 s:=inttostr(money);
 len:=length(s);
 while (length(s)>0) do begin
  if (length(s) mod 3)= 2 then
   begin
    ch:=copy(s,1,2);
    eng:=eng+englishword(strtoint(ch));
    if trunc(length(s)/3)=3 then
     eng:=eng+' Billion '
    else if trunc(length(s)/3)=2 then
     begin
      if (len<10) then
       eng:=eng+' Million '
      else if (len>=10) and (englishword(strtoint(ch))<>'') then
       eng:=eng+' Million '
     end
    else if trunc(length(s)/3)=1 then
     begin
      if (len<7) then
       eng:=eng+' Thousand '
      else if (len>=7) and (englishword(strtoint(ch))<>'') then
       eng:=eng+' Thousand '
     end;
    if length(s)<=2 then
     s:=''
    else
     s:=copy(s,3,length(s)-2);
   end

  else if (length(s) mod 3)= 1 then
   begin
    ch:=copy(s,1,1);
    eng:=eng+englishword(strtoint(ch));
    if trunc(length(s)/3)=3 then
     eng:=eng+' Billion '
    else if trunc(length(s)/3)=2 then
     begin
      if (len<10) then
       eng:=eng+' Million '
      else if (len>=10) and (englishword(strtoint(ch))<>'') then
       eng:=eng+' Million '
     end
    else if trunc(length(s)/3)=1 then
     begin
      if (len<7) then
       eng:=eng+' Thousand '
      else if (len>=7) and (englishword(strtoint(ch))<>'') then
       eng:=eng+' Thousand '
     end;
    if length(s)<=1 then
     s:=''
    else
     s:=copy(s,2,length(s)-1);
   end

  else
   begin
    ch:=copy(s,1,1);
    if ch<>'0' then
     begin
      eng:=eng+englishword(strtoint(ch))+' Hundred ';
     end;
    if length(s)<=1 then
     s:=''
    else
     s:=copy(s,2,length(s)-1);
   end;
 end;
 result:=eng;
end;


function TForm1.englishword(n: Integer): String;
Var
 c: String;
 pre,pos: String;
begin
 if (n<20) then
  begin
   if n=0 then result:='';
   if n=1 then result:='One';
   if n=2 then result:='Two';
   if n=3 then result:='Three';
   if n=4 then result:='Four';
   if n=5 then result:='Five';
   if n=6 then result:='Six';
   if n=7 then result:='Seven';
   if n=8 then result:='Eight';
   if n=9 then result:='Nine';
   if n=10 then result:='Ten';
   if n=11 then result:='Eleven';
   if n=12 then result:='Twelve';
   if n=13 then result:='Thirteen';
   if n=14 then result:='Fourteen';
   if n=15 then result:='Fifteen';
   if n=16 then result:='Sixteen';
   if n=17 then result:='Seventeen';
   if n=18 then result:='Eighteen';
   if n=19 then result:='Nineteen';
  end
 else
  begin
   c:=inttostr(n);
   if c[1]='2' then pre:='Twenty';
   if c[1]='3' then pre:='Thirty';
   if c[1]='4' then pre:='Forty';
   if c[1]='5' then pre:='Fifty';
   if c[1]='6' then pre:='Sixty';
   if c[1]='7' then pre:='Seventy';
   if c[1]='8' then pre:='Eighty';
   if c[1]='9' then pre:='Ninety';
   if c[2]='0' then pos:='';   
   if c[2]='1' then pos:='One';
   if c[2]='2' then pos:='Two';
   if c[2]='3' then pos:='Three';
   if c[2]='4' then pos:='Four';
   if c[2]='5' then pos:='Five';
   if c[2]='6' then pos:='Six';
   if c[2]='7' then pos:='Seven';
   if c[2]='8' then pos:='Eight';
   if c[2]='9' then pos:='Nine';

   if pos='' then
     result:=pre
   else
     result:=pre+'-'+pos;
  end;
end;



end.
